UNIT MFTimer;
INTERFACE

  FUNCTION  NewTimer(VAR X, XADD : LONGINT):BYTE;

IMPLEMENTATION
USES  DOS;              (* For set and getintvec.                           *)
CONST MaxTimers = 100;  (* If you need more, be my guest ..                 *)
      SaveInt = $67;    (*20 Needed to be able to maintain the INT chain.*)
(****************************************************************************)
VAR TIMER  : ARRAY[0..MaxTimers,0..1] OF ^LONGINT; (* Array of pointers.    *)
    CURTM  : BYTE;      (* number of timers currently allocated.            *)
    INVOLD : WORD;      (* Count to see if we need to call the oldint.      *)
    CLOCKF : WORD;
    OldExit : Pointer;  (* To maintain termination chain.                   *)
(****************************************************************************)
VAR OldTimer : FarPOINTER; (* Pointer to the oldtimer interrupt.            *)
    OldSave  : FarPOINTER; (* Pointer to whatever was at the $67 interrupt  *)
(****************************************************************************)
  PROCEDURE MyTimer(eip, eax, ecx, edx, ebx, esp, ebp, esi, edi: dword;
                     gs, fs, es: word); interrupt;
  VAR W1 : WORD;
  BEGIN
   (* If needed, increment all the timers. *)
    IF CurTM <> 0 THEN
    For W1 := 0 TO CurTm - 1 DO
      LONGINT(Timer[W1,0]^) := LONGINT(Timer[W1,0]^)+LONGINT(Timer[W1,1]^);
   (* Once every ClockF ticks call the old timer interrupt *)
    IF INVOLD = ClockF THEN BEGIN   (*20 Does'nt change dos time anymore *)
     INVOLD := 0;
     ASM
       Int SaveInt              (* Call the old interrupt *)
     END;
    END ELSE PORT[$20] := $20;  (* or send an eoi *)
   (* Increment the counter. (invold = invoke old) *)
    INC(INVOLD);
  END;
(****************************************************************************)
(* Creates a new timer in the list.                                         *)
(****************************************************************************)
  FUNCTION NewTimer(VAR X, Xadd : LONGINT):BYTE;
  BEGIN
    (* Add the addresses of the variables to the list. *)
     Timer[CurTm,0] := @X;
     Timer[CurTm,1] := @Xadd;
    (* That's one more timer to do 72.8 times per sec :) *)
     INC(CurTm);
     NewTimer := CurTM - 1; (* Returns a reference to the timer. *)
  END;
(****************************************************************************)
(* Remember : Verry first statement to be executed !!!!                     *)
(****************************************************************************)
  PROCEDURE InitTimer;
  VAR NewCounter : WORD;
  BEGIN
   ASM CLI END;                   (*20 Uses int 8 now, disables ints. *)
   (* Save old vector and set new one *)
    GetIntVec($08, OldTimer);      (* Get int8 vector, store in oldtimer  *)
    GetIntVec(SaveInt, OldSave);   (* Get int67 vector, store in saveint  *)
    SetIntVec(SaveInt, OldTimer);  (* set int67 to old timer.             *)
    SetIntVec($08, @MyTimer);      (* Set int8 to our new timerroutine.   *)

    NewCounter:=1193180 div 364;
    ClockF    :=round(364*1000 / 18206);

   (* Set timer parameters ... we need a bit more than 18.2 ticks per sec *)
    PORT[$43] := $36;         (* This means i'm setting the timer's params. *)
    PORT[$40] := LO(NewCounter);  (* Now send the new resolution, LSB first.*)
    PORT[$40] := HI(NewCounter);(* Normally this number is 65535 or $FFFF.  *)
   ASM STI END; (* Don't forget to put interrupts back on :) *)
  END;
(****************************************************************************)
(* Restores the original timer                                              *)
(****************************************************************************)
  PROCEDURE RestoreTimer;
  BEGIN
   (* Restore exit chain *)
    ExitProc := OldExit;
   (* Set interrupts of. *)
    ASM CLI END;
   (* Restore timer's parameters ... *)
    PORT[$43] := $36;
    PORT[$40] := $FF;
    PORT[$40] := $FF;
   (* Old interrupt vector back *)
    GetIntVec(SaveInt,OldTimer); (* old timer vector back in oldtimer *)
    SetIntVec($08,OldTimer);     (* Set $8 to old timer again         *)
    SetIntVec(SaveInt,OldSave);  (* Restore the old int $67           *)
   (* Set interrupts back on *)
    ASM STI END;
  END;
(****************************************************************************)
(* Main Program                                                             *)
(****************************************************************************)
BEGIN
  OldExit := ExitProc;        (* Store old exitprocedure        *)
  ExitProc := @RestoreTimer;  (* AutoExit :)                    *)
  CurTM := 0;                 (* no timers yet :)               *)
  InvOld := 0;                (* To keep the system time a.o.k. *)
  InitTimer;                  (* AutoInit                       *)
END.